diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/internet/helper/rip-helper.h ns-3.44/src/internet/helper/rip-helper.h
--- ns-3.43/src/internet/helper/rip-helper.h	2024-10-09 16:41:09.880655800 -0700
+++ ns-3.44/src/internet/helper/rip-helper.h	2025-03-09 16:55:49.387371000 -0700
@@ -19,9 +19,9 @@
 {
 
 /**
- * \ingroup ipv4Helpers
+ * @ingroup ipv4Helpers
  *
- * \brief Helper class that adds RIP routing to nodes.
+ * @brief Helper class that adds RIP routing to nodes.
  *
  * This class is expected to be used in conjunction with
  * ns3::InternetStackHelper::SetRoutingHelper
@@ -37,9 +37,9 @@
     RipHelper();
 
     /**
-     * \brief Construct an RipHelper from another previously
+     * @brief Construct an RipHelper from another previously
      * initialized instance (Copy Constructor).
-     * \param o The object to copy from.
+     * @param o The object to copy from.
      */
     RipHelper(const RipHelper& o);
 
@@ -49,7 +49,7 @@
     RipHelper& operator=(const RipHelper&) = delete;
 
     /**
-     * \returns pointer to clone of this RipHelper
+     * @returns pointer to clone of this RipHelper
      *
      * This method is mainly for internal use by the other helpers;
      * clients are expected to free the dynamic memory allocated by this method
@@ -57,16 +57,16 @@
     RipHelper* Copy() const override;
 
     /**
-     * \param node the node on which the routing protocol will run
-     * \returns a newly-created routing protocol
+     * @param node the node on which the routing protocol will run
+     * @returns a newly-created routing protocol
      *
      * This method will be called by ns3::InternetStackHelper::Install
      */
     Ptr<Ipv4RoutingProtocol> Create(Ptr<Node> node) const override;
 
     /**
-     * \param name the name of the attribute to set
-     * \param value the value of the attribute to set.
+     * @param name the name of the attribute to set
+     * @param value the value of the attribute to set.
      *
      * This method controls the attributes of ns3::Ripng
      */
@@ -78,49 +78,49 @@
      * have been assigned. The Install() method should have previously been
      * called by the user.
      *
-     * \param c NetDeviceContainer of the set of net devices for which the
+     * @param c NetDeviceContainer of the set of net devices for which the
      *          SixLowPanNetDevice should be modified to use a fixed stream
-     * \param stream first stream index to use
-     * \return the number of stream indices assigned by this helper
+     * @param stream first stream index to use
+     * @return the number of stream indices assigned by this helper
      */
     int64_t AssignStreams(NodeContainer c, int64_t stream);
 
     /**
-     * \brief Install a default route in the node.
+     * @brief Install a default route in the node.
      *
      * The traffic will be routed to the nextHop, located on the specified
      * interface, unless a more specific route is found.
      *
-     * \param node the node
-     * \param nextHop the next hop
-     * \param interface the network interface
+     * @param node the node
+     * @param nextHop the next hop
+     * @param interface the network interface
      */
     void SetDefaultRouter(Ptr<Node> node, Ipv4Address nextHop, uint32_t interface);
 
     /**
-     * \brief Exclude an interface from RIP protocol.
+     * @brief Exclude an interface from RIP protocol.
      *
      * You have to call this function \a before installing RIP in the nodes.
      *
      * Note: the exclusion means that RIP will not be propagated on that interface.
      * The network prefix on that interface will be still considered in RIP.
      *
-     * \param node the node
-     * \param interface the network interface to be excluded
+     * @param node the node
+     * @param interface the network interface to be excluded
      */
     void ExcludeInterface(Ptr<Node> node, uint32_t interface);
 
     /**
-     * \brief Set a metric for an interface.
+     * @brief Set a metric for an interface.
      *
      * You have to call this function \a before installing RIP in the nodes.
      *
      * Note: RIP will apply the metric on route message reception.
      * As a consequence, interface metric should be set on the receiver.
      *
-     * \param node the node
-     * \param interface the network interface
-     * \param metric the interface metric
+     * @param node the node
+     * @param interface the network interface
+     * @param metric the interface metric
      */
     void SetInterfaceMetric(Ptr<Node> node, uint32_t interface, uint8_t metric);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/internet/helper/ripng-helper.h ns-3.44/src/internet/helper/ripng-helper.h
--- ns-3.43/src/internet/helper/ripng-helper.h	2024-10-09 16:41:09.880655800 -0700
+++ ns-3.44/src/internet/helper/ripng-helper.h	2025-03-09 16:55:49.387371000 -0700
@@ -21,9 +21,9 @@
 {
 
 /**
- * \ingroup ipv6Helpers
+ * @ingroup ipv6Helpers
  *
- * \brief Helper class that adds RIPng routing to nodes.
+ * @brief Helper class that adds RIPng routing to nodes.
  *
  * This class is expected to be used in conjunction with
  * ns3::InternetStackHelper::SetRoutingHelper
@@ -39,9 +39,9 @@
     RipNgHelper();
 
     /**
-     * \brief Construct an RipNgHelper from another previously
+     * @brief Construct an RipNgHelper from another previously
      * initialized instance (Copy Constructor).
-     * \param o The object to copy from.
+     * @param o The object to copy from.
      */
     RipNgHelper(const RipNgHelper& o);
 
@@ -51,7 +51,7 @@
     RipNgHelper& operator=(const RipNgHelper&) = delete;
 
     /**
-     * \returns pointer to clone of this RipNgHelper
+     * @returns pointer to clone of this RipNgHelper
      *
      * This method is mainly for internal use by the other helpers;
      * clients are expected to free the dynamic memory allocated by this method
@@ -59,16 +59,16 @@
     RipNgHelper* Copy() const override;
 
     /**
-     * \param node the node on which the routing protocol will run
-     * \returns a newly-created routing protocol
+     * @param node the node on which the routing protocol will run
+     * @returns a newly-created routing protocol
      *
      * This method will be called by ns3::InternetStackHelper::Install
      */
     Ptr<Ipv6RoutingProtocol> Create(Ptr<Node> node) const override;
 
     /**
-     * \param name the name of the attribute to set
-     * \param value the value of the attribute to set.
+     * @param name the name of the attribute to set
+     * @param value the value of the attribute to set.
      *
      * This method controls the attributes of ns3::RipNg
      */
@@ -80,49 +80,49 @@
      * have been assigned. The Install() method should have previously been
      * called by the user.
      *
-     * \param c NetDeviceContainer of the set of net devices for which the
+     * @param c NetDeviceContainer of the set of net devices for which the
      *          SixLowPanNetDevice should be modified to use a fixed stream
-     * \param stream first stream index to use
-     * \return the number of stream indices assigned by this helper
+     * @param stream first stream index to use
+     * @return the number of stream indices assigned by this helper
      */
     int64_t AssignStreams(NodeContainer c, int64_t stream);
 
     /**
-     * \brief Install a default route in the node.
+     * @brief Install a default route in the node.
      *
      * The traffic will be routed to the nextHop, located on the specified
      * interface, unless a more specific route is found.
      *
-     * \param node the node
-     * \param nextHop the next hop
-     * \param interface the network interface
+     * @param node the node
+     * @param nextHop the next hop
+     * @param interface the network interface
      */
     void SetDefaultRouter(Ptr<Node> node, Ipv6Address nextHop, uint32_t interface);
 
     /**
-     * \brief Exclude an interface from RIPng protocol.
+     * @brief Exclude an interface from RIPng protocol.
      *
      * You have to call this function \a before installing RIPng in the nodes.
      *
      * Note: the exclusion means that RIPng will not be propagated on that interface.
      * The network prefix on that interface will be still considered in RIPng.
      *
-     * \param node the node
-     * \param interface the network interface to be excluded
+     * @param node the node
+     * @param interface the network interface to be excluded
      */
     void ExcludeInterface(Ptr<Node> node, uint32_t interface);
 
     /**
-     * \brief Set a metric for an interface.
+     * @brief Set a metric for an interface.
      *
      * You have to call this function \a before installing RIPng in the nodes.
      *
      * Note: RIPng will apply the metric on route message reception.
      * As a consequence, interface metric should be set on the receiver.
      *
-     * \param node the node
-     * \param interface the network interface
-     * \param metric the interface metric
+     * @param node the node
+     * @param interface the network interface
+     * @param metric the interface metric
      */
     void SetInterfaceMetric(Ptr<Node> node, uint32_t interface, uint8_t metric);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/internet/model/arp-cache.h ns-3.44/src/internet/model/arp-cache.h
--- ns-3.43/src/internet/model/arp-cache.h	2024-10-09 16:41:09.880655800 -0700
+++ ns-3.44/src/internet/model/arp-cache.h	2025-03-09 16:55:49.387371000 -0700
@@ -32,8 +32,8 @@
 class Ipv4Header;
 
 /**
- * \ingroup arp
- * \brief An ARP cache
+ * @ingroup arp
+ * @brief An ARP cache
  *
  * A cached lookup table for translating layer 3 addresses to layer 2.
  * This implementation does lookups from IPv4 to a MAC address
@@ -42,8 +42,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     class Entry;
@@ -56,52 +56,52 @@
     ArpCache& operator=(const ArpCache&) = delete;
 
     /**
-     * \brief Set the NetDevice and Ipv4Interface associated with the ArpCache
+     * @brief Set the NetDevice and Ipv4Interface associated with the ArpCache
      *
-     * \param device The hardware NetDevice associated with this ARP cache
-     * \param interface the Ipv4Interface associated with this ARP cache
+     * @param device The hardware NetDevice associated with this ARP cache
+     * @param interface the Ipv4Interface associated with this ARP cache
      */
     void SetDevice(Ptr<NetDevice> device, Ptr<Ipv4Interface> interface);
     /**
-     * \brief Returns the NetDevice that this ARP cache is associated with
-     * \return The NetDevice that this ARP cache is associated with
+     * @brief Returns the NetDevice that this ARP cache is associated with
+     * @return The NetDevice that this ARP cache is associated with
      */
     Ptr<NetDevice> GetDevice() const;
     /**
-     * \brief Returns the Ipv4Interface that this ARP cache is associated with
-     * \return the Ipv4Interface that this ARP cache is associated with
+     * @brief Returns the Ipv4Interface that this ARP cache is associated with
+     * @return the Ipv4Interface that this ARP cache is associated with
      */
     Ptr<Ipv4Interface> GetInterface() const;
 
     /**
-     * \brief Set the time the entry will be in ALIVE state (unless refreshed)
-     * \param aliveTimeout the Alive state timeout
+     * @brief Set the time the entry will be in ALIVE state (unless refreshed)
+     * @param aliveTimeout the Alive state timeout
      */
     void SetAliveTimeout(Time aliveTimeout);
     /**
-     * \brief Set the time the entry will be in DEAD state before being removed
-     * \param deadTimeout the Dead state timeout
+     * @brief Set the time the entry will be in DEAD state before being removed
+     * @param deadTimeout the Dead state timeout
      */
     void SetDeadTimeout(Time deadTimeout);
     /**
-     * \brief Set the time the entry will be in WAIT_REPLY state
-     * \param waitReplyTimeout the WAIT_REPLY state timeout
+     * @brief Set the time the entry will be in WAIT_REPLY state
+     * @param waitReplyTimeout the WAIT_REPLY state timeout
      */
     void SetWaitReplyTimeout(Time waitReplyTimeout);
 
     /**
-     * \brief Get the time the entry will be in ALIVE state (unless refreshed)
-     * \returns the Alive state timeout
+     * @brief Get the time the entry will be in ALIVE state (unless refreshed)
+     * @returns the Alive state timeout
      */
     Time GetAliveTimeout() const;
     /**
-     * \brief Get the time the entry will be in DEAD state before being removed
-     * \returns the Dead state timeout
+     * @brief Get the time the entry will be in DEAD state before being removed
+     * @returns the Dead state timeout
      */
     Time GetDeadTimeout() const;
     /**
-     * \brief Get the time the entry will be in WAIT_REPLY state
-     * \returns the WAIT_REPLY state timeout
+     * @brief Get the time the entry will be in WAIT_REPLY state
+     * @returns the WAIT_REPLY state timeout
      */
     Time GetWaitReplyTimeout() const;
 
@@ -110,7 +110,7 @@
      * the cache to generate an Arp request when the WaitReply
      * time expires and a retransmission must be sent
      *
-     * \param arpRequestCallback Callback for transmitting an Arp request.
+     * @param arpRequestCallback Callback for transmitting an Arp request.
      */
     void SetArpRequestCallback(Callback<void, Ptr<const ArpCache>, Ipv4Address> arpRequestCallback);
     /**
@@ -120,167 +120,167 @@
      */
     void StartWaitReplyTimer();
     /**
-     * \brief Do lookup in the ARP cache against an IP address
-     * \param destination The destination IPv4 address to lookup the MAC address
+     * @brief Do lookup in the ARP cache against an IP address
+     * @param destination The destination IPv4 address to lookup the MAC address
      * of
-     * \return An ArpCache::Entry with info about layer 2
+     * @return An ArpCache::Entry with info about layer 2
      */
     ArpCache::Entry* Lookup(Ipv4Address destination);
     /**
-     * \brief Do lookup in the ARP cache against a MAC address
-     * \param destination The destination MAC address to lookup
+     * @brief Do lookup in the ARP cache against a MAC address
+     * @param destination The destination MAC address to lookup
      * of
-     * \return A std::list of ArpCache::Entry with info about layer 2
+     * @return A std::list of ArpCache::Entry with info about layer 2
      */
     std::list<ArpCache::Entry*> LookupInverse(Address destination);
     /**
-     * \brief Add an Ipv4Address to this ARP cache
-     * \param to the destination address of the ARP entry.
-     * \returns A pointer to a new ARP Entry.
+     * @brief Add an Ipv4Address to this ARP cache
+     * @param to the destination address of the ARP entry.
+     * @returns A pointer to a new ARP Entry.
      */
     ArpCache::Entry* Add(Ipv4Address to);
     /**
-     * \brief Remove an entry.
-     * \param entry pointer to delete it from the list
+     * @brief Remove an entry.
+     * @param entry pointer to delete it from the list
      */
     void Remove(ArpCache::Entry* entry);
     /**
-     * \brief Clear the ArpCache of all entries
+     * @brief Clear the ArpCache of all entries
      */
     void Flush();
 
     /**
-     * \brief Print the ARP cache entries
+     * @brief Print the ARP cache entries
      *
-     * \param stream the ostream the ARP cache entries is printed to
+     * @param stream the ostream the ARP cache entries is printed to
      */
     void PrintArpCache(Ptr<OutputStreamWrapper> stream);
 
     /**
-     * \brief Clear the ArpCache of all Auto-Generated entries
+     * @brief Clear the ArpCache of all Auto-Generated entries
      */
     void RemoveAutoGeneratedEntries();
 
     /**
-     * \brief Pair of a packet and an Ipv4 header.
+     * @brief Pair of a packet and an Ipv4 header.
      */
     typedef std::pair<Ptr<Packet>, Ipv4Header> Ipv4PayloadHeaderPair;
 
     /**
-     * \brief A record that that holds information about an ArpCache entry
+     * @brief A record that that holds information about an ArpCache entry
      */
     class Entry
     {
       public:
         /**
-         * \brief Constructor
-         * \param arp The ArpCache this entry belongs to
+         * @brief Constructor
+         * @param arp The ArpCache this entry belongs to
          */
         Entry(ArpCache* arp);
 
         /**
-         * \brief Changes the state of this entry to dead
+         * @brief Changes the state of this entry to dead
          */
         void MarkDead();
         /**
-         * \param macAddress
+         * @param macAddress
          */
         void MarkAlive(Address macAddress);
         /**
-         * \param waiting
+         * @param waiting
          */
         void MarkWaitReply(Ipv4PayloadHeaderPair waiting);
         /**
-         * \brief Changes the state of this entry to Permanent.
+         * @brief Changes the state of this entry to Permanent.
          *
          * The entry must have a valid MacAddress.
          */
         void MarkPermanent();
         /**
-         * \brief Changes the state of this entry to auto-generated.
+         * @brief Changes the state of this entry to auto-generated.
          *
          * The entry must have a valid MacAddress.
          */
         void MarkAutoGenerated();
         /**
-         * \param waiting
-         * \return
+         * @param waiting
+         * @return
          */
         bool UpdateWaitReply(Ipv4PayloadHeaderPair waiting);
         /**
-         * \return True if the state of this entry is dead; false otherwise.
+         * @return True if the state of this entry is dead; false otherwise.
          */
         bool IsDead();
         /**
-         * \return True if the state of this entry is alive; false otherwise.
+         * @return True if the state of this entry is alive; false otherwise.
          */
         bool IsAlive();
         /**
-         * \return True if the state of this entry is wait_reply; false otherwise.
+         * @return True if the state of this entry is wait_reply; false otherwise.
          */
         bool IsWaitReply();
         /**
-         * \return True if the state of this entry is permanent; false otherwise.
+         * @return True if the state of this entry is permanent; false otherwise.
          */
         bool IsPermanent();
         /**
-         * \return True if the state of this entry is auto-generated; false otherwise.
+         * @return True if the state of this entry is auto-generated; false otherwise.
          */
         bool IsAutoGenerated();
         /**
-         * \return The MacAddress of this entry
+         * @return The MacAddress of this entry
          */
         Address GetMacAddress() const;
         /**
-         * \return The Ipv4Address for this entry
+         * @return The Ipv4Address for this entry
          */
         Ipv4Address GetIpv4Address() const;
         /**
-         * \param macAddress The MacAddress for this entry
+         * @param macAddress The MacAddress for this entry
          */
         void SetMacAddress(Address macAddress);
         /**
-         * \param destination The Ipv4Address for this entry
+         * @param destination The Ipv4Address for this entry
          */
         void SetIpv4Address(Ipv4Address destination);
         /**
-         * \return True if this entry has timed out; false otherwise.
+         * @return True if this entry has timed out; false otherwise.
          *
          * This function returns true if the time elapsed strictly exceeds
          * the timeout value (i.e., is not less than or equal to the timeout).
          */
         bool IsExpired() const;
         /**
-         * \returns 0 is no packet is pending, the next packet to send if
+         * @returns 0 is no packet is pending, the next packet to send if
          *            packets are pending.
          */
         Ipv4PayloadHeaderPair DequeuePending();
         /**
-         * \brief Clear the pending packet list
+         * @brief Clear the pending packet list
          */
         void ClearPendingPacket();
         /**
-         * \returns number of retries that have been sent for an ArpRequest
+         * @returns number of retries that have been sent for an ArpRequest
          *  in WaitReply state.
          */
         uint32_t GetRetries() const;
         /**
-         * \brief Increment the counter of number of retries for an entry
+         * @brief Increment the counter of number of retries for an entry
          */
         void IncrementRetries();
         /**
-         * \brief Zero the counter of number of retries for an entry
+         * @brief Zero the counter of number of retries for an entry
          */
         void ClearRetries();
 
         /**
-         * \brief Update the entry when seeing a packet
+         * @brief Update the entry when seeing a packet
          */
         void UpdateSeen();
 
       private:
         /**
-         * \brief ARP cache entry states
+         * @brief ARP cache entry states
          */
         enum ArpCacheEntryState_e
         {
@@ -292,8 +292,8 @@
         };
 
         /**
-         * \brief Returns the entry timeout
-         * \returns the entry timeout
+         * @brief Returns the entry timeout
+         * @returns the entry timeout
          */
         Time GetTimeout() const;
 
@@ -308,11 +308,11 @@
 
   private:
     /**
-     * \brief ARP Cache container
+     * @brief ARP Cache container
      */
     typedef std::map<Ipv4Address, ArpCache::Entry*> Cache;
     /**
-     * \brief ARP Cache container iterator
+     * @brief ARP Cache container iterator
      */
     typedef std::map<Ipv4Address, ArpCache::Entry*>::iterator CacheI;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/internet/model/arp-header.cc ns-3.44/src/internet/model/arp-header.cc
--- ns-3.43/src/internet/model/arp-header.cc	2024-10-09 16:41:09.880655800 -0700
+++ ns-3.44/src/internet/model/arp-header.cc	2025-03-09 16:55:49.387371000 -0700
@@ -27,6 +27,7 @@
 {
     NS_LOG_FUNCTION(this << sourceHardwareAddress << sourceProtocolAddress
                          << destinationHardwareAddress << destinationProtocolAddress);
+    m_hardwareType = DetermineHardwareType(sourceHardwareAddress);
     m_type = ARP_TYPE_REQUEST;
     m_macSource = sourceHardwareAddress;
     m_macDest = destinationHardwareAddress;
@@ -42,6 +43,7 @@
 {
     NS_LOG_FUNCTION(this << sourceHardwareAddress << sourceProtocolAddress
                          << destinationHardwareAddress << destinationProtocolAddress);
+    m_hardwareType = DetermineHardwareType(sourceHardwareAddress);
     m_type = ARP_TYPE_REPLY;
     m_macSource = sourceHardwareAddress;
     m_macDest = destinationHardwareAddress;
@@ -49,6 +51,22 @@
     m_ipv4Dest = destinationProtocolAddress;
 }
 
+ArpHeader::HardwareType
+ArpHeader::DetermineHardwareType(const Address& address) const
+{
+    NS_LOG_FUNCTION(this << address);
+    uint8_t addressLength = address.GetLength();
+    switch (addressLength)
+    {
+    case 6:
+        return HardwareType::ETHERNET;
+    case 8:
+        return HardwareType::EUI_64;
+    default:
+        return HardwareType::UNKNOWN;
+    }
+}
+
 bool
 ArpHeader::IsRequest() const
 {
@@ -63,6 +81,13 @@
     return m_type == ARP_TYPE_REPLY;
 }
 
+ArpHeader::HardwareType
+ArpHeader::GetHardwareType() const
+{
+    NS_LOG_FUNCTION(this);
+    return m_hardwareType;
+}
+
 Address
 ArpHeader::GetSourceHardwareAddress() const
 {
@@ -114,7 +139,8 @@
     NS_LOG_FUNCTION(this << &os);
     if (IsRequest())
     {
-        os << "request "
+        os << "hardware type: " << GetHardwareType() << " "
+           << "request "
            << "source mac: " << m_macSource << " "
            << "source ipv4: " << m_ipv4Source << " "
            << "dest ipv4: " << m_ipv4Dest;
@@ -122,7 +148,8 @@
     else
     {
         NS_ASSERT(IsReply());
-        os << "reply "
+        os << "hardware type: " << GetHardwareType() << " "
+           << "reply "
            << "source mac: " << m_macSource << " "
            << "source ipv4: " << m_ipv4Source << " "
            << "dest mac: " << m_macDest << " "
@@ -151,8 +178,7 @@
     Buffer::Iterator i = start;
     NS_ASSERT(m_macSource.GetLength() == m_macDest.GetLength());
 
-    /* ethernet */
-    i.WriteHtonU16(0x0001);
+    i.WriteHtonU16(static_cast<uint16_t>(m_hardwareType));
     /* ipv4 */
     i.WriteHtonU16(0x0800);
     i.WriteU8(m_macSource.GetLength());
@@ -169,10 +195,10 @@
 {
     NS_LOG_FUNCTION(this << &start);
     Buffer::Iterator i = start;
-    i.Next(2);                                // Skip HRD
-    uint32_t protocolType = i.ReadNtohU16();  // Read PRO
-    uint32_t hardwareAddressLen = i.ReadU8(); // Read HLN
-    uint32_t protocolAddressLen = i.ReadU8(); // Read PLN
+    m_hardwareType = static_cast<HardwareType>(i.ReadNtohU16()); // Read HTYPE
+    uint32_t protocolType = i.ReadNtohU16();                     // Read PRO
+    uint32_t hardwareAddressLen = i.ReadU8();                    // Read HLN
+    uint32_t protocolAddressLen = i.ReadU8();                    // Read PLN
 
     //
     // It is implicit here that we have a protocol type of 0x800 (IP).
@@ -185,12 +211,27 @@
         return 0;
     }
 
-    m_type = i.ReadNtohU16();                     // Read OP
-    ReadFrom(i, m_macSource, hardwareAddressLen); // Read SHA (size HLN)
-    ReadFrom(i, m_ipv4Source);                    // Read SPA (size PLN == 4)
-    ReadFrom(i, m_macDest, hardwareAddressLen);   // Read THA (size HLN)
-    ReadFrom(i, m_ipv4Dest);                      // Read TPA (size PLN == 4)
+    m_type = static_cast<ArpType_e>(i.ReadNtohU16()); // Read OP
+    ReadFrom(i, m_macSource, hardwareAddressLen);     // Read SHA (size HLN)
+    ReadFrom(i, m_ipv4Source);                        // Read SPA (size PLN == 4)
+    ReadFrom(i, m_macDest, hardwareAddressLen);       // Read THA (size HLN)
+    ReadFrom(i, m_ipv4Dest);                          // Read TPA (size PLN == 4)
     return GetSerializedSize();
 }
 
+std::ostream&
+operator<<(std::ostream& os, ArpHeader::HardwareType hardwareType)
+{
+    switch (hardwareType)
+    {
+    case ArpHeader::HardwareType::ETHERNET:
+        return (os << "Ethernet");
+    case ArpHeader::HardwareType::EUI_64:
+        return (os << "EUI-64");
+    case ArpHeader::HardwareType::UNKNOWN:
+        return (os << "Unknown Hardware Type");
+    }
+    return os << "Unrecognized Hardware Type(" << static_cast<uint16_t>(hardwareType) << ")";
+}
+
 } // namespace ns3
